def main():
	import pandas as pd
	import numpy as np
	import matplotlib.pyplot as plt

	fs = 50

	dataset = pd.read_csv('data_record.csv')
	a_std = np.array(dataset['a_std'])
	a_up = np.array(dataset['a_up'])
	g_std = np.array(dataset['g_std'])
	g_up = np.array(dataset['g_up'])
	gz = np.array(dataset['gz'])
	is_out = np.array(dataset['is_out'])

	out_idx = [i for i in range(len(is_out)) if is_out[i] == 1]

	n_samples = len(gz)
	T = n_samples / fs
	t = np.linspace(0, T, n_samples, endpoint = False)

	out_t = t[out_idx]
	out_gz = gz[out_idx]

	plt.figure(1)
	plt.clf()
	plt.plot(t, a_std, label = 'std variation of accelerate magnitude')
	plt.plot(t, a_up, label = 'Schmidt trigger output for accelerate')
	plt.plot(t, g_std, label = 'std variation of gyro magnitude')
	plt.plot(t, g_up, label = 'Schmidt trigger output for gyro')
	plt.plot(t, gz, label = 'gyro z')
	plt.scatter(out_t, out_gz)
	plt.grid(True)
	plt.legend(loc = 'upper left')

	plt.show()
	return 0

if __name__ == '__main__':
	exit(main())
